"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.renderToHtml = renderToHtml;

var _preactRenderToString = _interopRequireDefault(require("preact-render-to-string"));

var _preact = require("preact");

var _shiki = require("shiki");

const defaultPreStyle = bg => ({
  backgroundColor: bg,
  padding: "0.75rem 0.75rem",
  borderRadius: "0.25rem",
  overflow: "auto"
});

const defaultToolbarStyle = {
  display: "flex",
  position: "absolute",
  right: 0,
  color: "#eee",
  backgroundColor: "#393939aa",
  padding: "0.125rem 0.425rem",
  borderRadius: "0.125rem"
};

function renderToHtml(lines, options = {}) {
  const {
    bg = "#fff",
    langId = "",
    classPrefix
  } = options;
  const randomId = Math.floor(Math.random() * 65535);
  let node = (0, _preact.h)("div", {
    className: "shiki",
    style: {
      position: "relative",
      paddingTop: "0.75rem"
    }
  }, (0, _preact.h)("div", {
    className: "toolbar",
    style: defaultToolbarStyle
  }, langId && (0, _preact.h)("div", {
    className: "language-id",
    style: {}
  }, langId), (0, _preact.h)("div", {
    className: "copy-button",
    style: {
      marginLeft: "0.45rem"
    }
  }, (0, _preact.h)("button", {
    className: "copy-btn",
    "data-clipboard-target": `#code-${randomId}`
  }, "copy"))), (0, _preact.h)("pre", {
    className: `${classPrefix}${langId}`,
    style: defaultPreStyle(bg)
  }, (0, _preact.h)("code", {
    className: "code",
    id: `code-${randomId}`
  }, lines.map(l => (0, _preact.h)("div", {
    key: l.toString(),
    className: "line"
  }, l.map(token => {
    const cssDeclarations = {
      color: token.color || options.fg
    };

    if (token.fontStyle & _shiki.FontStyle.Italic) {
      cssDeclarations.fontStyle = "italic";
    }

    if (token.fontStyle & _shiki.FontStyle.Bold) {
      cssDeclarations.fontWeight = "bold";
    }

    if (token.fontStyle & _shiki.FontStyle.Underline) {
      cssDeclarations.textDecoration = "underline";
    }

    return (0, _preact.h)("span", {
      key: token.content,
      style: cssDeclarations
    }, token.content);
  }))))));
  return (0, _preactRenderToString.default)(node);
}